/* Seeed Grove ++ (C) 2015-2016 Stephane Charette <stephanecharette@gmail.com>
 * $Id: sg_GroveUART.hpp 1862 2016-05-25 00:06:15Z stephane $
 */

#pragma once

// Central include file for SeeedGrove++ is "sg++.hpp".

#include "sg_groves.hpp"
#include "sg_GroveBase.hpp"


namespace SG
{
	/** Base class for Groves that use the UART (Universal Asynchronous Receiver/Transmitter) interface.  When
	 * looking at the top of a %BeagleBone Green with the network interface towards the top and the Grove interfaces
	 * at the bottom, this is the right-hand-side Grove interface labelled @p J5.  On the board, you'll also see the
	 * labels @p RXD, @p TXD, @p 3V3, and @p GND.
	 *
	 * The other interface called @p J4 on the left side is the I2C Grove interface.
	 *
	 * @see @ref GroveI2C
	 * @see @ref GroveGPIO
	 */
	class GroveUART : public GroveBase
	{
		public:

			/// Constructor.
			GroveUART( const SG::EGroveType t=SG::EGroveType::kUnknown, const std::string &n="" );

			/// Destructor.
			virtual ~GroveUART( void );

			virtual bool is_grove_uart	( void ) const { return true;	}
			virtual bool is_grove_i2c	( void ) const { return false;	}
			virtual bool is_grove_gpio	( void ) const { return false;	}
	};
}
